diff --git a/src/qmplay2/NetworkAccess.cpp b/src/qmplay2/NetworkAccess.cpp
index 8a80b1b3..fa0da099 100644
--- a/src/qmplay2/NetworkAccess.cpp
+++ b/src/qmplay2/NetworkAccess.cpp
@@ -72,7 +72,7 @@ public:
         m_retries(params.retries),
         m_retryInterval(params.retryInterval),
         m_ctx(nullptr),
-        m_error(NetworkReply::Error::Ok),
+        m_error(NetworkReply::ErrorOk),
         m_aborted(false),
         m_afterOpen(false)
     {}
@@ -107,11 +107,11 @@ public:
     };
 
 private:
-    void run() override
+    void run()
     {
         const QString scheme = Functions::getUrlScheme(m_url);
         if (scheme.isEmpty() || scheme == "file")
-            m_error = NetworkReply::Error::UnsupportedScheme;
+            m_error = NetworkReply::ErrorUnsupportedScheme;
         else
         {
             AVIOInterruptCB interruptCB = {(int(*)(void*))::interruptCB, m_status};
@@ -133,37 +133,37 @@ private:
                 const int ret = avio_open2(&m_ctx, url, AVIO_FLAG_READ | AVIO_FLAG_DIRECT, &interruptCB, &options);
                 if (ret >= 0)
                 {
-                    m_error = NetworkReply::Error::Ok;
+                    m_error = NetworkReply::ErrorOk;
                     break;
                 }
                 switch (ret)
                 {
                     case AVERROR_HTTP_BAD_REQUEST:
-                        m_error = NetworkReply::Error::Connection400;
+                        m_error = NetworkReply::ErrorConnection400;
                         break;
                     case AVERROR_HTTP_UNAUTHORIZED:
-                        m_error = NetworkReply::Error::Connection401;
+                        m_error = NetworkReply::ErrorConnection401;
                         break;
                     case AVERROR_HTTP_FORBIDDEN:
-                        m_error = NetworkReply::Error::Connection403;
+                        m_error = NetworkReply::ErrorConnection403;
                         break;
                     case AVERROR_HTTP_NOT_FOUND:
-                        m_error = NetworkReply::Error::Connection404;
+                        m_error = NetworkReply::ErrorConnection404;
                         break;
                     case AVERROR_HTTP_OTHER_4XX:
-                        m_error = NetworkReply::Error::Connection4XX;
+                        m_error = NetworkReply::ErrorConnection4XX;
                         break;
                     case AVERROR_HTTP_SERVER_ERROR:
-                        m_error = NetworkReply::Error::Connection5XX;
+                        m_error = NetworkReply::ErrorConnection5XX;
                         continue; // Continue if server error (e.g. Service Temporarily Unavailable)
                     default:
-                        m_error = NetworkReply::Error::Connection;
+                        m_error = NetworkReply::ErrorConnection;
                         continue; // Continue if connection error
                 }
                 break;
             } while (--m_retries > 0 && doSleep(m_aborted, m_retryInterval));
 
-            if (m_error == NetworkReply::Error::Ok)
+            if (m_error == NetworkReply::ErrorOk)
             {
                 char *cookies = nullptr;
                 if (av_opt_get(m_ctx, "cookies", AV_OPT_SEARCH_CHILDREN, (uint8_t **)&cookies) >= 0)
@@ -182,7 +182,7 @@ private:
 
                 int64_t size = avio_size(m_ctx);
                 if (size >= m_maxSize)
-                    m_error = NetworkReply::Error::FileTooLarge;
+                    m_error = NetworkReply::ErrorFileTooLarge;
                 else
                 {
                     if (size < -1)
@@ -199,7 +199,7 @@ private:
                         if (received < 0) //Error
                         {
                             if (received != AVERROR_EOF)
-                                m_error = NetworkReply::Error::Download;
+                                m_error = NetworkReply::ErrorDownload;
                             break;
                         }
 
@@ -224,7 +224,7 @@ private:
 
                         if (pos + chunkSize >= m_maxSize)
                         {
-                            m_error = NetworkReply::Error::FileTooLarge;
+                            m_error = NetworkReply::ErrorFileTooLarge;
                             break;
                         }
                     }
@@ -257,11 +257,11 @@ void NetworkReply::abort()
 
 bool NetworkReply::hasError() const
 {
-    return (error() != Error::Ok);
+    return (error() != ErrorOk);
 }
 NetworkReply::Error NetworkReply::error() const
 {
-    return m_priv->m_aborted ? Error::Aborted : m_priv->m_error;
+    return m_priv->m_aborted ? ErrorAborted : m_priv->m_error;
 }
 
 QByteArray NetworkReply::getCookies() const
@@ -300,7 +300,7 @@ NetworkReply::Wait NetworkReply::waitForFinished(int ms)
             }
         }
     }
-    return ret ? (hasError() ? Wait::Error : Wait::Ok) : Wait::Timeout;
+    return ret ? (hasError() ? WaitError : WaitOk) : WaitTimeout;
 }
 
 NetworkReply::NetworkReply(const QString &url, const QByteArray &postData, const QByteArray &rawHeaders, const NetworkAccessParams &params) :
@@ -378,7 +378,7 @@ bool NetworkAccess::startAndWait(IOController<NetworkReply> &ioCtrl, const QStri
     m_params->retries = oldRetries;
     if (ok)
     {
-        if (ioCtrl->waitForFinished() == NetworkReply::Wait::Ok)
+        if (ioCtrl->waitForFinished() == NetworkReply::WaitOk)
             return true;
         ioCtrl.reset();
     }
diff --git a/src/qmplay2/NetworkAccess.hpp b/src/qmplay2/NetworkAccess.hpp
index dd020baa..669eb5a0 100644
--- a/src/qmplay2/NetworkAccess.hpp
+++ b/src/qmplay2/NetworkAccess.hpp
@@ -26,7 +26,7 @@
 class NetworkReplyPriv;
 struct NetworkAccessParams;
 
-class QMPLAY2SHAREDLIB_EXPORT NetworkReply final : public QObject, public BasicIO
+class QMPLAY2SHAREDLIB_EXPORT NetworkReply : public QObject, public BasicIO
 {
     Q_OBJECT
 
@@ -34,36 +34,36 @@ class QMPLAY2SHAREDLIB_EXPORT NetworkReply final : public QObject, public BasicI
     friend class NetworkAccess;
 
 public:
-    enum class Error
+    enum Error
     {
-        Ok = 0,
-        UnsupportedScheme,
-        Connection,
-        Connection400,
-        Connection401,
-        Connection403,
-        Connection404,
-        Connection4XX,
-        Connection5XX,
-        FileTooLarge,
-        Download,
-        Aborted
+        ErrorOk = 0,
+        ErrorUnsupportedScheme,
+        ErrorConnection,
+        ErrorConnection400,
+        ErrorConnection401,
+        ErrorConnection403,
+        ErrorConnection404,
+        ErrorConnection4XX,
+        ErrorConnection5XX,
+        ErrorFileTooLarge,
+        ErrorDownload,
+        ErrorAborted
     };
-    Q_ENUM(Error)
 
-    enum class Wait
+    enum Wait
     {
-        Ok = 0,
-        Timeout,
-        Error
+        WaitOk = 0,
+        WaitTimeout,
+        WaitError
     };
-    Q_ENUM(Wait)
+
+    Q_ENUMS(Error Wait)
 
     ~NetworkReply();
 
     QString url() const;
 
-    void abort() override;
+    void abort();
 
     bool hasError() const;
     Error error() const;
diff --git a/src/qmplay2/NetworkAccessJS.cpp b/src/qmplay2/NetworkAccessJS.cpp
index 16a9f829..06215b94 100644
--- a/src/qmplay2/NetworkAccessJS.cpp
+++ b/src/qmplay2/NetworkAccessJS.cpp
@@ -83,25 +83,16 @@ int NetworkAccessJS::start(QJSValue args, QJSValue onFinished, QJSValue onProgre
     auto reply = m_net->start(url, postData, rawHeaders);
     const auto id = QMPlay2Core.getCommonJS()->insertNetworkReply(reply);
 
-    connect(reply, &NetworkReply::finished,
-            reply, [=]() mutable {
-        if (onFinished.isCallable())
-        {
-            onFinished.call({
-                static_cast<int>(reply->error()),
-                QString(reply->readAll()),
-                QString(reply->getCookies()),
-                id,
-            });
-        }
-        reply->deleteLater();
-    });
+    ReplyCallbacks callbacks;
+    callbacks.id = id;
+    callbacks.onFinished = onFinished;
+    callbacks.onProgress = onProgress;
+    m_replyCallbacks[reply] = callbacks;
+
+    connect(reply, SIGNAL(finished()), this, SLOT(onReplyFinished()));
     if (onProgress.isCallable())
     {
-        connect(reply, &NetworkReply::downloadProgress,
-                this, [=](int pos, int total) mutable {
-            onProgress.call({pos, total});
-        });
+        connect(reply, SIGNAL(downloadProgress(int,int)), this, SLOT(onReplyDownloadProgress(int,int)));
     }
 
     return id;
@@ -131,3 +122,45 @@ QVariantMap NetworkAccessJS::startAndWait(QJSValue args, const int ioControllerI
         {"ok", false}
     };
 }
+
+void NetworkAccessJS::onReplyFinished()
+{
+    NetworkReply *reply = qobject_cast<NetworkReply*>(sender());
+    if (!reply)
+        return;
+
+    auto it = m_replyCallbacks.find(reply);
+    if (it != m_replyCallbacks.end())
+    {
+        ReplyCallbacks callbacks = it.value();
+        m_replyCallbacks.erase(it);
+
+        if (callbacks.onFinished.isCallable())
+        {
+            callbacks.onFinished.call({
+                static_cast<int>(reply->error()),
+                QString(reply->readAll()),
+                QString(reply->getCookies()),
+                callbacks.id,
+            });
+        }
+        reply->deleteLater();
+    }
+}
+
+void NetworkAccessJS::onReplyDownloadProgress(int pos, int total)
+{
+    NetworkReply *reply = qobject_cast<NetworkReply*>(sender());
+    if (!reply)
+        return;
+
+    auto it = m_replyCallbacks.find(reply);
+    if (it != m_replyCallbacks.end())
+    {
+        ReplyCallbacks &callbacks = it.value();
+        if (callbacks.onProgress.isCallable())
+        {
+            callbacks.onProgress.call({pos, total});
+        }
+    }
+}
diff --git a/src/qmplay2/NetworkAccessJS.hpp b/src/qmplay2/NetworkAccessJS.hpp
index 8cc77097..4d8586b6 100644
--- a/src/qmplay2/NetworkAccessJS.hpp
+++ b/src/qmplay2/NetworkAccessJS.hpp
@@ -29,6 +29,17 @@ public:
     Q_INVOKABLE int start(QJSValue args, QJSValue onFinished = {}, QJSValue onProgress = {});
     Q_INVOKABLE QVariantMap startAndWait(QJSValue args, const int ioControllerId);
 
+private slots:
+    void onReplyFinished();
+    void onReplyDownloadProgress(int pos, int total);
+
 private:
+    struct ReplyCallbacks {
+        int id;
+        QJSValue onFinished;
+        QJSValue onProgress;
+    };
+
     NetworkAccess *const m_net;
+    QHash<QObject*, ReplyCallbacks> m_replyCallbacks;
 };
diff --git a/src/qmplay2/NotifiesAndroid.hpp b/src/qmplay2/NotifiesAndroid.hpp
index 81791835..b962090b 100644
--- a/src/qmplay2/NotifiesAndroid.hpp
+++ b/src/qmplay2/NotifiesAndroid.hpp
@@ -22,10 +22,10 @@
 
 #include <QObject>
 
-class NotifiesAndroid final : public QObject, public Notifies
+class NotifiesAndroid : public QObject, public Notifies
 {
     Q_OBJECT
 
-    bool doNotify(const QString &title, const QString &message, const int ms, const QPixmap &pixmap, const int iconId = 0) override;
-    bool doNotify(const QString &title, const QString &message, const int ms, const QImage &image, const int iconId = 0) override;
+    bool doNotify(const QString &title, const QString &message, const int ms, const QPixmap &pixmap, const int iconId = 0);
+    bool doNotify(const QString &title, const QString &message, const int ms, const QImage &image, const int iconId = 0);
 };
diff --git a/src/qmplay2/NotifiesFreedesktop.hpp b/src/qmplay2/NotifiesFreedesktop.hpp
index 4a26d5fa..ed89d3b9 100644
--- a/src/qmplay2/NotifiesFreedesktop.hpp
+++ b/src/qmplay2/NotifiesFreedesktop.hpp
@@ -26,7 +26,7 @@
 class OrgFreedesktopNotificationsInterface;
 class QDBusPendingCallWatcher;
 
-class QMPLAY2SHAREDLIB_EXPORT NotifiesFreedesktop final : public QObject, public Notifies
+class QMPLAY2SHAREDLIB_EXPORT NotifiesFreedesktop : public QObject, public Notifies
 {
     Q_OBJECT
 
@@ -35,8 +35,8 @@ public:
     ~NotifiesFreedesktop();
 
 private:
-    bool doNotify(const QString &title, const QString &message, const int ms, const QPixmap &pixmap, const int iconId = 0) override;
-    bool doNotify(const QString &title, const QString &message, const int ms, const QImage &image, const int iconId = 0) override;
+    bool doNotify(const QString &title, const QString &message, const int ms, const QPixmap &pixmap, const int iconId = 0);
+    bool doNotify(const QString &title, const QString &message, const int ms, const QImage &image, const int iconId = 0);
 
 private slots:
     void callFinished(QDBusPendingCallWatcher *watcher);
diff --git a/src/qmplay2/NotifiesMacOS.hpp b/src/qmplay2/NotifiesMacOS.hpp
index 64ff1d52..007cdd62 100644
--- a/src/qmplay2/NotifiesMacOS.hpp
+++ b/src/qmplay2/NotifiesMacOS.hpp
@@ -22,15 +22,15 @@
 
 #include <QList>
 
-class NotifiesMacOS final : public Notifies
+class NotifiesMacOS : public Notifies
 {
 public:
     NotifiesMacOS();
     ~NotifiesMacOS();
 
 private:
-    bool doNotify(const QString &title, const QString &message, const int ms, const QPixmap &pixmap, const int iconId) override;
-    bool doNotify(const QString &title, const QString &message, const int ms, const QImage &image, const int iconId) override;
+    bool doNotify(const QString &title, const QString &message, const int ms, const QPixmap &pixmap, const int iconId);
+    bool doNotify(const QString &title, const QString &message, const int ms, const QImage &image, const int iconId);
 
     void *m_notificationItem;
     QList<void *> m_notifications;
diff --git a/src/qmplay2/NotifiesMacOS.mm b/src/qmplay2/NotifiesMacOS.mm
index e4147435..54cd511e 100644
--- a/src/qmplay2/NotifiesMacOS.mm
+++ b/src/qmplay2/NotifiesMacOS.mm
@@ -57,11 +57,29 @@ bool NotifiesMacOS::doNotify(const QString &title, const QString &message, const
 
     NSUserNotification *notification = [[NSUserNotification alloc] init];
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
     notification.title = title.toNSString();
     notification.informativeText = message.toNSString();
+#else
+    // Qt4: No toNSString(), use UTF8 C string
+    notification.title = [NSString stringWithUTF8String:title.toUtf8().constData()];
+    notification.informativeText = [NSString stringWithUTF8String:message.toUtf8().constData()];
+#endif
     if (!pixmap.isNull())
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 8, 0)
         auto cgimage = pixmap.toImage().toCGImage();
+#else
+        // Qt4: No toCGImage(), manual conversion
+        QImage img = pixmap.toImage().convertToFormat(QImage::Format_ARGB32);
+        CGColorSpaceRef colorSpace = CGColorSpaceCreateDeviceRGB();
+        CGDataProviderRef dataProvider = CGDataProviderCreateWithData(NULL, img.bits(), img.byteCount(), NULL);
+        CGImageRef cgimage = CGImageCreate(img.width(), img.height(), 8, 32, img.bytesPerLine(),
+                                           colorSpace, kCGImageAlphaFirst | kCGBitmapByteOrder32Host,
+                                           dataProvider, NULL, false, kCGRenderingIntentDefault);
+        CGDataProviderRelease(dataProvider);
+        CGColorSpaceRelease(colorSpace);
+#endif
         auto bitmapRep = [[NSBitmapImageRep alloc] initWithCGImage:cgimage];
         auto image = [[NSImage alloc] init];
         [image addRepresentation:bitmapRep];
@@ -76,6 +94,7 @@ bool NotifiesMacOS::doNotify(const QString &title, const QString &message, const
         [notification release];
     else
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 4, 0)
         QTimer::singleShot(ms + 500 /* Add 500 ms for animation */, [this, notification] {
             const int idx = m_notifications.indexOf(notification);
             if (idx > -1)
@@ -85,6 +104,12 @@ bool NotifiesMacOS::doNotify(const QString &title, const QString &message, const
             }
         });
         m_notifications.append(notification);
+#else
+        // Qt4: QTimer::singleShot doesn't support lambda, and NotifiesMacOS is not a QObject.
+        // For Qt4, we simply let the notification persist. The system will handle cleanup.
+        // Store it so we can clean up in the destructor.
+        m_notifications.append(notification);
+#endif
     }
 
     return true;
diff --git a/src/qmplay2/NotifiesTray.hpp b/src/qmplay2/NotifiesTray.hpp
index df0f5616..0756b26b 100644
--- a/src/qmplay2/NotifiesTray.hpp
+++ b/src/qmplay2/NotifiesTray.hpp
@@ -20,16 +20,16 @@
 
 #include <Notifies.hpp>
 
-class QMPLAY2SHAREDLIB_EXPORT NotifiesTray final : public Notifies
+class QMPLAY2SHAREDLIB_EXPORT NotifiesTray : public Notifies
 {
 public:
     NotifiesTray(QSystemTrayIcon *tray);
     ~NotifiesTray() final = default;
 
 private:
-    bool doNotify(const QString &title, const QString &message, const int ms, const QPixmap &pixmap, const int iconId) override;
-    bool doNotify(const QString &title, const QString &message, const int ms, const QImage &image, const int iconId) override;
-    bool doNotify(const QString &title, const QString &message, const int ms, const int iconId) override;
+    bool doNotify(const QString &title, const QString &message, const int ms, const QPixmap &pixmap, const int iconId);
+    bool doNotify(const QString &title, const QString &message, const int ms, const QImage &image, const int iconId);
+    bool doNotify(const QString &title, const QString &message, const int ms, const int iconId);
 
     QSystemTrayIcon *m_tray;
 };
diff --git a/src/qmplay2/QMPlay2Core.cpp b/src/qmplay2/QMPlay2Core.cpp
index ab97b7dc..7e8df9f3 100644
--- a/src/qmplay2/QMPlay2Core.cpp
+++ b/src/qmplay2/QMPlay2Core.cpp
@@ -28,8 +28,7 @@
 #include <Version.hpp>
 #include <Module.hpp>
 
-#include <QLoggingCategory>
-#include <QStandardPaths>
+#include <QDesktopServices>
 #include <QApplication>
 #include <QLibraryInfo>
 #include <QTranslator>
@@ -37,14 +36,18 @@
 #include <QLibrary>
 #include <QPointer>
 #include <QLocale>
-#include <QWindow>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    #include <QWindow>
+#endif
 #include <QFile>
 #include <QDir>
 #if defined Q_OS_WIN
     #include <windows.h>
     #include <powrprof.h>
-#elif defined Q_OS_MACOS
-    #include <QOperatingSystemVersion>
+#elif defined Q_OS_MAC
+    #if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+        #include <QOperatingSystemVersion>
+    #endif
 #elif !defined Q_OS_ANDROID && !defined Q_OS_HAIKU && defined DBUS_PM
     #include <QDBusConnection>
     #include <QDBusInterface>
@@ -93,14 +96,19 @@ private:
 
 /**/
 
-Q_LOGGING_CATEGORY(ffmpeglog, "FFmpegLog")
-
 static void avQMPlay2LogHandler(void *avcl, int level, const char *fmt, va_list vl)
 {
     if (level <= AV_LOG_FATAL)
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 5, 0)
         const QByteArray msg = QString::vasprintf(fmt, vl).trimmed().toUtf8();
-        qCCritical(ffmpeglog) << msg.constData();
+#else
+        // Qt4: QString::vasprintf doesn't exist, use vsprintf manually
+        char buffer[4096];
+        vsnprintf(buffer, sizeof(buffer), fmt, vl);
+        const QByteArray msg = QString::fromUtf8(buffer).trimmed().toUtf8();
+#endif
+        qCritical() << "FFmpegLog:" << msg.constData();
     }
     else
     {
@@ -212,8 +220,9 @@ int QMPlay2CoreClass::getCPUMaxAlign()
 #ifdef USE_OPENGL
 bool QMPlay2CoreClass::isGlOnWindowForced()
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     static bool forced = [] {
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
 #   if defined(MAC_OS_X_VERSION_10_14) && (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_14)
         return (QOperatingSystemVersion::current() <= QOperatingSystemVersion::MacOSHighSierra);
 #   else
@@ -225,6 +234,31 @@ bool QMPlay2CoreClass::isGlOnWindowForced()
 #endif
     }();
     return forced;
+#else
+    // Qt4: No lambda initialization support, use static variable
+    static bool forced = false;
+    static bool initialized = false;
+    if (!initialized)
+    {
+        initialized = true;
+#ifdef Q_OS_MAC
+#   if defined(MAC_OS_X_VERSION_10_14) && (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_14)
+        // Qt4 doesn't have QOperatingSystemVersion, assume older macOS
+        forced = true;
+#   else
+        forced = true;
+#   endif
+#else
+        // Qt4: No QApplication::platformName(), check for Android at compile time
+#ifdef Q_OS_ANDROID
+        forced = true;
+#else
+        forced = false;
+#endif
+#endif
+    }
+    return forced;
+#endif
 }
 #endif
 
@@ -245,10 +279,20 @@ void QMPlay2CoreClass::init(bool loadModulesAndGpu, bool modulesInSubdirs, const
     {
 #if defined(Q_OS_WIN) || defined(Q_OS_HAIKU)
         settingsDir = QFileInfo(QSettings(QSettings::IniFormat, QSettings::UserScope, QString()).fileName()).absolutePath() + "/QMPlay2/";
-#elif defined(Q_OS_MACOS)
-        settingsDir = Functions::cleanPath(QStandardPaths::standardLocations(QStandardPaths::AppDataLocation).value(0));
+#elif defined(Q_OS_MAC)
+        #if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+            settingsDir = Functions::cleanPath(QStandardPaths::standardLocations(QStandardPaths::AppDataLocation).value(0));
+        #else
+            // Qt4: Use QDesktopServices::storageLocation
+            settingsDir = Functions::cleanPath(QDesktopServices::storageLocation(QDesktopServices::DataLocation));
+        #endif
 #else
-        const QString configSettingsDir(QStandardPaths::standardLocations(QStandardPaths::ConfigLocation).value(0) + "/QMPlay2/");
+        #if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+            const QString configSettingsDir(QStandardPaths::standardLocations(QStandardPaths::ConfigLocation).value(0) + "/QMPlay2/");
+        #else
+            // Qt4: Use QDesktopServices::storageLocation for config location
+            const QString configSettingsDir(QDesktopServices::storageLocation(QDesktopServices::DataLocation) + "/QMPlay2/");
+        #endif
         const QString homeSettingsDir(QDir::homePath() + "/.qmplay2/");
         if (QFileInfo(configSettingsDir).isDir() || !QFileInfo(homeSettingsDir).isDir())
         {
@@ -347,7 +391,7 @@ void QMPlay2CoreClass::init(bool loadModulesAndGpu, bool modulesInSubdirs, const
         }
 
         QStringList pluginsName;
-        for (const QFileInfo &fInfo : std::as_const(pluginsList))
+        for (const QFileInfo &fInfo : pluginsList)
         {
             if (QLibrary::isLibrary(fInfo.filePath()))
             {
@@ -371,7 +415,10 @@ void QMPlay2CoreClass::init(bool loadModulesAndGpu, bool modulesInSubdirs, const
                         }
                         const quint8 qtMajorVersion = ((v >> 24) & 0xFF);
                         const quint8 qtMinorVersion = ((v >> 16) & 0xFF);
-                        if (qtMajorVersion != QT_VERSION_MAJOR || qtMinorVersion < QT_VERSION_MINOR)
+                        // Qt4: Extract major/minor from QT_VERSION
+                        const quint8 currentQtMajor = ((QT_VERSION >> 16) & 0xFF);
+                        const quint8 currentQtMinor = ((QT_VERSION >> 8) & 0xFF);
+                        if (qtMajorVersion != currentQtMajor || qtMinorVersion < currentQtMinor)
                         {
                             log(fInfo.fileName() + " - " + tr("mismatch module Qt version"), AddTimeToLog | ErrorLog | SaveLog);
                             return false;
@@ -418,7 +465,7 @@ void QMPlay2CoreClass::quit()
 {
     if (settingsDir.isEmpty())
         return;
-    for (Module *pluginInstance : std::as_const(pluginsInstance))
+    for (Module *pluginInstance : pluginsInstance)
         delete pluginInstance;
     pluginsInstance.clear();
     videoFilters.clear();
@@ -441,7 +488,7 @@ void QMPlay2CoreClass::quit()
 
 bool QMPlay2CoreClass::canSuspend()
 {
-#if defined Q_OS_WIN || defined Q_OS_MACOS
+#if defined Q_OS_WIN || defined Q_OS_MAC
     m_suspend = 1;
     return true;
 #elif defined DBUS_PM
@@ -466,7 +513,7 @@ void QMPlay2CoreClass::suspend()
 
 #if defined Q_OS_WIN
     SetSuspendState(false, false, false);
-#elif defined Q_OS_MACOS
+#elif defined Q_OS_MAC
     Q_UNUSED(system("pmset sleepnow > /dev/null 2>&1 &"));
 #elif defined DBUS_PM
     auto connection = QDBusConnection::systemBus();
@@ -515,6 +562,7 @@ QStringList QMPlay2CoreClass::getModules(const QString &type, int typeLen) const
         const int idx = availableModules.indexOf(module);
         if (idx > -1)
         {
+            // Qt4: QStringList::remove() is removeAt()
             availableModules.removeAt(idx);
             modules += module;
         }
@@ -524,7 +572,12 @@ QStringList QMPlay2CoreClass::getModules(const QString &type, int typeLen) const
 
 qreal QMPlay2CoreClass::getVideoDevicePixelRatio() const
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     return getVideoDock()->devicePixelRatioF();
+#else
+    // Qt4: No HiDPI support, always return 1.0
+    return 1.0;
+#endif
 }
 
 QIcon QMPlay2CoreClass::getIconFromTheme(const QString &iconName, const QIcon &fallback)
@@ -592,7 +645,13 @@ void QMPlay2CoreClass::setLanguage()
         lang = QLocale::system().name();
     if (translator->load(lang, langDir))
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         lang = QFileInfo(translator->filePath()).baseName();
+#else
+        // Qt4: QTranslator::filePath() doesn't exist, extract locale from lang string
+        // Keep only the locale part (e.g., "en_US" or "en")
+        lang = lang.left(lang.indexOf('_') > 0 ? lang.indexOf('_') : lang.length());
+#endif
     }
     else
     {
diff --git a/src/qmplay2/QMPlay2Extensions.cpp b/src/qmplay2/QMPlay2Extensions.cpp
index a8875079..969e1a49 100644
--- a/src/qmplay2/QMPlay2Extensions.cpp
+++ b/src/qmplay2/QMPlay2Extensions.cpp
@@ -32,7 +32,7 @@ void QMPlay2Extensions::openExtensions()
                 if (QMPlay2Ext)
                     guiExtensionsList.append(QMPlay2Ext);
             }
-    for (QMPlay2Extensions *QMPlay2Ext : std::as_const(guiExtensionsList))
+    for (QMPlay2Extensions *QMPlay2Ext : guiExtensionsList)
         QMPlay2Ext->init();
 }
 
diff --git a/src/qmplay2/Reader.cpp b/src/qmplay2/Reader.cpp
index 07bd386c..ac65434a 100644
--- a/src/qmplay2/Reader.cpp
+++ b/src/qmplay2/Reader.cpp
@@ -59,7 +59,7 @@ class IODeviceReader : public Reader
     }
 
 protected:
-    bool open() override
+    bool open()
     {
         return m_io->open(QIODevice::ReadOnly);
     }
diff --git a/src/qmplay2/Settings.cpp b/src/qmplay2/Settings.cpp
index a93f4047..b64d8777 100644
--- a/src/qmplay2/Settings.cpp
+++ b/src/qmplay2/Settings.cpp
@@ -90,7 +90,7 @@ QVariant Settings::get(const QString &key, const QVariant &def) const
 
 void Settings::flushCache()
 {
-    for (const QString &key : std::as_const(toRemove))
+    for (const QString &key : toRemove)
         QSettings::remove(key);
     toRemove.clear();
 
diff --git a/src/qmplay2/Slider.cpp b/src/qmplay2/Slider.cpp
index a6b96c3b..90c434ba 100644
--- a/src/qmplay2/Slider.cpp
+++ b/src/qmplay2/Slider.cpp
@@ -31,6 +31,9 @@ Slider::Slider() :
 {
     setMouseTracking(true);
 }
+Slider::~Slider()
+{
+}
 
 void Slider::setValue(int val)
 {
@@ -149,9 +152,15 @@ void Slider::mouseMoveEvent(QMouseEvent *e)
 }
 void Slider::wheelEvent(QWheelEvent *e)
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     const auto angleDelta  = e->angleDelta();
+    const int delta = (angleDelta.y() != 0 ? angleDelta.y() : angleDelta.x());
+#else
+    // Qt4: Use delta() which returns an int
+    const int delta = e->delta();
+#endif
     int v;
-    if ((angleDelta.y() != 0 ? angleDelta.y() : angleDelta.x()) > 0)
+    if (delta > 0)
         v = value() + wheelStep;
     else
         v = value() - wheelStep;
diff --git a/src/qmplay2/Slider.hpp b/src/qmplay2/Slider.hpp
index b06e0dcc..ef749b59 100644
--- a/src/qmplay2/Slider.hpp
+++ b/src/qmplay2/Slider.hpp
@@ -22,12 +22,12 @@
 
 #include <QSlider>
 
-class QMPLAY2SHAREDLIB_EXPORT Slider final : public QSlider
+class QMPLAY2SHAREDLIB_EXPORT Slider : public QSlider
 {
     Q_OBJECT
 public:
     Slider();
-    ~Slider() final = default;
+    ~Slider();
 
     inline bool ignoringValueChanged() const
     {
@@ -45,12 +45,12 @@ public slots:
     }
     void drawRange(int first, int second);
 protected:
-    void paintEvent(QPaintEvent *) override;
-    void mousePressEvent(QMouseEvent *) override;
-    void mouseReleaseEvent(QMouseEvent *) override;
-    void mouseMoveEvent(QMouseEvent *) override;
-    void wheelEvent(QWheelEvent *) override;
-    void enterEvent(Q_ENTER_EVENT *) override;
+    void paintEvent(QPaintEvent *);
+    void mousePressEvent(QMouseEvent *);
+    void mouseReleaseEvent(QMouseEvent *);
+    void mouseMoveEvent(QMouseEvent *);
+    void wheelEvent(QWheelEvent *);
+    void enterEvent(Q_ENTER_EVENT *);
 private:
     int getMousePos(const QPoint &pos);
 
diff --git a/src/qmplay2/SndResampler.cpp b/src/qmplay2/SndResampler.cpp
index d7e6a3d8..951ce8a4 100644
--- a/src/qmplay2/SndResampler.cpp
+++ b/src/qmplay2/SndResampler.cpp
@@ -182,7 +182,7 @@ void SndResampler::convert(const QByteArray &src, QByteArray &dst, bool flush)
         if (!m_rubberBandStretcher)
         {
             RubberBandStretcher::Options options = RubberBandStretcher::OptionProcessRealTime | RubberBandStretcher::OptionChannelsTogether;
-            if (QStringLiteral(RUBBERBAND_VERSION) != QStringLiteral("3.0.0") || m_dstSamplerate >= 40000)
+            if (QString(RUBBERBAND_VERSION) != QString("3.0.0") || m_dstSamplerate >= 40000)
             {
                 // Workaround for RubberBand 3.0.0 bug:
                 // - low sample rates - bad audio quality
diff --git a/src/qmplay2/StreamInfo.hpp b/src/qmplay2/StreamInfo.hpp
index 59a033b0..51bb95c7 100644
--- a/src/qmplay2/StreamInfo.hpp
+++ b/src/qmplay2/StreamInfo.hpp
@@ -25,6 +25,8 @@
 #include <QVector>
 #include <QPair>
 
+#include <limits>
+
 extern "C" {
     #include <libavcodec/avcodec.h>
 }
@@ -122,7 +124,7 @@ public:
 
     // Video only
     AVRational fps = {0, 1};
-    double rotation = qQNaN();
+    double rotation = std::numeric_limits<double>::quiet_NaN();
     bool spherical = false;
     bool custom_sar = false;
 
